<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-29 12:18:44 */

/* Busqueda de registros de la tabla cr_llamada_cabecera. */
abstract class BaseCr_llamada_cabeceraFN extends Cr_llamada_cabeceraBN
{
    /* Declaracion de constantes */
    const IdCabecera = "cr_llamada_cabecera.IDCABECERA";
    const FechaTraslado = "FECHATRASLADO";
    const TipoPrestamo = "cr_llamada_cabecera.TIPOPRESTAMO";
    const NumeroPrestamo = "NUMEROPRESTAMO";
    const Estado = "ESTADO";
    const IdCliente = "IDCLIENTE";
    const NombreCliente = "NOMBRECLIENTE";
    const FechaRegistro = "FECHAREGISTRO";
    const UsuarioRegistro = "USUARIOREGISTRO";
    const Eliminado = "ELIMINADO";
    const UsuarioEliminado = "USUARIOELIMINADO";
    const FechaEliminado = "FECHAELIMINADO";
    const IdMercado = "IDMERCADO";
    const NombreMercado = "NOMBREMERCADO";
    const FechaInicio = "FECHAINICIO";
    const FechaFinal = "FECHAFINAL";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        //$o_Resource = $o_DBConnect->getResource();
        $o_Resource = $o_DBConnect;
        return $o_Resource;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "cr_llamada_cabecera.IdCabecera AS IdCabecera, ";
        $s_SQLQuery .= "cr_llamada_cabecera.FechaTraslado AS FechaTraslado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.TipoPrestamo AS TipoPrestamo, ";
        $s_SQLQuery .= "cr_llamada_cabecera.NumeroPrestamo AS NumeroPrestamo, ";
        $s_SQLQuery .= "cr_llamada_cabecera.Estado AS Estado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.IdCliente AS IdCliente, ";
        $s_SQLQuery .= "cr_llamada_cabecera.NombreCliente AS NombreCliente, ";
        $s_SQLQuery .= "cr_llamada_cabecera.FechaRegistro AS FechaRegistro, ";
        $s_SQLQuery .= "cr_llamada_cabecera.UsuarioRegistro AS UsuarioRegistro, ";
        $s_SQLQuery .= "cr_llamada_cabecera.Eliminado AS Eliminado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.UsuarioEliminado AS UsuarioEliminado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.FechaEliminado AS FechaEliminado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.IdMercado AS IdMercado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.NombreMercado AS NombreMercado, ";
        $s_SQLQuery .= "cr_llamada_cabecera.FechaInicio AS FechaInicio, ";
        $s_SQLQuery .= "cr_llamada_cabecera.FechaFinal AS FechaFinal ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }
    
     /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const)
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto Cr_llamada_cabeceraBN */
    public function setByBN( Cr_llamada_cabeceraBN $o_Cr_llamada_cabeceraBN )
    {
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdCabecera() ) )
        {
            $this->setIdCabecera( $o_Cr_llamada_cabeceraBN->getIdCabecera() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaTraslado() ) )
        {
            $this->setFechaTraslado( $o_Cr_llamada_cabeceraBN->getFechaTraslado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getTipoPrestamo() ) )
        {
            $this->setTipoPrestamo( $o_Cr_llamada_cabeceraBN->getTipoPrestamo() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNumeroPrestamo() ) )
        {
            $this->setNumeroPrestamo( $o_Cr_llamada_cabeceraBN->getNumeroPrestamo() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_llamada_cabeceraBN->getEstado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_llamada_cabeceraBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNombreCliente() ) )
        {
            $this->setNombreCliente( $o_Cr_llamada_cabeceraBN->getNombreCliente() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_llamada_cabeceraBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_llamada_cabeceraBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_llamada_cabeceraBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_llamada_cabeceraBN->getUsuarioEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_llamada_cabeceraBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdMercado() ) )
        {
            $this->setIdMercado( $o_Cr_llamada_cabeceraBN->getIdMercado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNombreMercado() ) )
        {
            $this->setNombreMercado( $o_Cr_llamada_cabeceraBN->getNombreMercado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_Cr_llamada_cabeceraBN->getFechaInicio() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaFinal() ) )
        {
            $this->setFechaFinal( $o_Cr_llamada_cabeceraBN->getFechaFinal() );
        }
    }

    /* Busca un registro por su llave primaria */
    public function selectByPK( $i_IdCabecera )
    {
        if( is_null( $i_IdCabecera ) ){ $i_IdCabecera = -1; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_llamada_cabecera 
        				LEFT JOIN cr_llamada_movimiento ON cr_llamada_movimiento.IdCabecera =  cr_llamada_cabecera.IdCabecera";
        $s_SQLQuery .= " WHERE cr_llamada_cabecera.IdCabecera = ".$i_IdCabecera." ";
        $s_SQLQuery .= "LIMIT 1;";
		//echo $s_SQLQuery;
        $o_Cr_llamada_cabeceraBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_llamada_cabeceraBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_Cr_llamada_cabeceraBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdCabecera() ) ) $s_SQLQuery .= "cr_llamada_cabecera.IdCabecera = ".$this->getIdCabecera()." AND ";
        if ( !is_null( $this->getFechaTraslado() ) ) $s_SQLQuery .= "cr_llamada_cabecera.FechaTraslado = '".$this->getFechaTraslado()."' AND ";
        if ( !is_null( $this->getTipoPrestamo() ) ) $s_SQLQuery .= "cr_llamada_cabecera.TipoPrestamo = '".$this->getTipoPrestamo()."' AND ";
        if ( !is_null( $this->getNumeroPrestamo() ) ) $s_SQLQuery .= "cr_llamada_cabecera.NumeroPrestamo = ".$this->getNumeroPrestamo()." AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "cr_llamada_cabecera.Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getIdCliente() ) ) $s_SQLQuery .= "cr_llamada_cabecera.IdCliente = ".$this->getIdCliente()." AND ";
        if ( !is_null( $this->getNombreCliente() ) ) $s_SQLQuery .= "NombreCliente = '".$this->getNombreCliente()."' AND ";
        if ( !is_null( $this->getFechaRegistro() ) ) $s_SQLQuery .= "FechaRegistro = '".$this->getFechaRegistro()."' AND ";
        if ( !is_null( $this->getUsuarioRegistro() ) ) $s_SQLQuery .= "UsuarioRegistro = '".$this->getUsuarioRegistro()."' AND ";
        if ( !is_null( $this->getEliminado() ) ) $s_SQLQuery .= "cr_llamada_cabecera.Eliminado = ".$this->getEliminado()." AND ";
        if ( !is_null( $this->getUsuarioEliminado() ) ) $s_SQLQuery .= "UsuarioEliminado = '".$this->getUsuarioEliminado()."' AND ";
        if ( !is_null( $this->getFechaEliminado() ) ) $s_SQLQuery .= "FechaEliminado = '".$this->getFechaEliminado()."' AND ";
        if ( !is_null( $this->getIdMercado() ) ) $s_SQLQuery .= "cr_llamada_cabecera.IdMercado = ".$this->getIdMercado()." AND ";
        if ( !is_null( $this->getNombreMercado() ) ) $s_SQLQuery .= "cr_llamada_cabecera.NombreMercado = '".$this->getNombreMercado()."' AND ";
        if ( !is_null( $this->getFechaInicio() ) ) $s_SQLQuery .= "cr_llamada_cabecera.FechaInicio = '".$this->getFechaInicio()."' AND ";
        if ( !is_null( $this->getFechaFinal() ) ) $s_SQLQuery .= "cr_llamada_cabecera.FechaFinal = '".$this->getFechaFinal()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM cr_llamada_cabecera 
        				LEFT JOIN cr_llamada_movimiento ON cr_llamada_movimiento.IdCabecera =  cr_llamada_cabecera.IdCabecera
        				LEFT JOIN cr_cliente ON cr_llamada_cabecera.IdCliente =  cr_cliente.IdCliente
        				WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
         if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        //echo $s_SQLQuery;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        
        $num_rows = 0;
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $num_rows = $a_SQLRow->cnt;
        }
        return $num_rows;
    }

    /* Busca varios registros por los campos establecidos */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_llamada_cabecera 
        				LEFT JOIN cr_llamada_movimiento ON cr_llamada_movimiento.IdCabecera =  cr_llamada_cabecera.IdCabecera
        				LEFT JOIN cr_cliente ON cr_llamada_cabecera.IdCliente =  cr_cliente.IdCliente
        				WHERE ";
        $s_SQLQuery .= $this->buildConsult();
         if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";
		//echo $s_SQLQuery;
        $a_Cr_llamada_cabeceraBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        while ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_llamada_cabeceraBN = $this->insertObjectBN( $a_SQLRow );
            $a_Cr_llamada_cabeceraBN[] = $o_Cr_llamada_cabeceraBN;
        }
        return $a_Cr_llamada_cabeceraBN;
    }

    /* Devuelve un objeto Cr_llamada_cabeceraBN desde un objeto propel */
    public function insertObjectBN( $o_Cr_llamada_cabecera )
    {
        $o_Cr_llamada_cabeceraBN = new Cr_llamada_cabeceraBN();
        if ( !is_null( $o_Cr_llamada_cabecera->IdCabecera ) ) $o_Cr_llamada_cabeceraBN->setIdCabecera( ( integer ) $o_Cr_llamada_cabecera->IdCabecera );
        if ( !is_null( $o_Cr_llamada_cabecera->FechaTraslado ) ) $o_Cr_llamada_cabeceraBN->setFechaTraslado( utilTimestamp::getTimestamp( $o_Cr_llamada_cabecera->FechaTraslado, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_cabecera->TipoPrestamo ) ) $o_Cr_llamada_cabeceraBN->setTipoPrestamo( $o_Cr_llamada_cabecera->TipoPrestamo );
        if ( !is_null( $o_Cr_llamada_cabecera->NumeroPrestamo ) ) $o_Cr_llamada_cabeceraBN->setNumeroPrestamo( ( integer ) $o_Cr_llamada_cabecera->NumeroPrestamo );
        if ( !is_null( $o_Cr_llamada_cabecera->Estado ) ) $o_Cr_llamada_cabeceraBN->setEstado( $o_Cr_llamada_cabecera->Estado );
        if ( !is_null( $o_Cr_llamada_cabecera->IdCliente ) ) $o_Cr_llamada_cabeceraBN->setIdCliente( ( integer ) $o_Cr_llamada_cabecera->IdCliente );
        if ( !is_null( $o_Cr_llamada_cabecera->NombreCliente ) ) $o_Cr_llamada_cabeceraBN->setNombreCliente( $o_Cr_llamada_cabecera->NombreCliente );
        if ( !is_null( $o_Cr_llamada_cabecera->FechaRegistro ) ) $o_Cr_llamada_cabeceraBN->setFechaRegistro( utilTimestamp::getTimestamp( $o_Cr_llamada_cabecera->FechaRegistro, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_cabecera->UsuarioRegistro ) ) $o_Cr_llamada_cabeceraBN->setUsuarioRegistro( $o_Cr_llamada_cabecera->UsuarioRegistro );
        if ( !is_null( $o_Cr_llamada_cabecera->Eliminado ) ) $o_Cr_llamada_cabeceraBN->setEliminado( ( integer ) $o_Cr_llamada_cabecera->Eliminado );
        if ( !is_null( $o_Cr_llamada_cabecera->UsuarioEliminado ) ) $o_Cr_llamada_cabeceraBN->setUsuarioEliminado( $o_Cr_llamada_cabecera->UsuarioEliminado );
        if ( !is_null( $o_Cr_llamada_cabecera->FechaEliminado ) ) $o_Cr_llamada_cabeceraBN->setFechaEliminado( utilTimestamp::getTimestamp( $o_Cr_llamada_cabecera->FechaEliminado, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_cabecera->IdMercado ) ) $o_Cr_llamada_cabeceraBN->setIdMercado( ( integer ) $o_Cr_llamada_cabecera->IdMercado );
        if ( !is_null( $o_Cr_llamada_cabecera->NombreMercado ) ) $o_Cr_llamada_cabeceraBN->setNombreMercado( $o_Cr_llamada_cabecera->NombreMercado );
        if ( !is_null( $o_Cr_llamada_cabecera->FechaInicio ) ) $o_Cr_llamada_cabeceraBN->setFechaInicio( utilTimestamp::getTimestamp( $o_Cr_llamada_cabecera->FechaInicio, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_llamada_cabecera->FechaFinal ) ) $o_Cr_llamada_cabeceraBN->setFechaFinal( utilTimestamp::getTimestamp( $o_Cr_llamada_cabecera->FechaFinal, "Y-m-d H:i:s" ) );
        return $o_Cr_llamada_cabeceraBN;
    }
}
?>